using System;
using System.Collections.Generic;

namespace Cmt6.Models.LinqToSql
{
    public class EntityFactory : IEntityFactory
    {
        public static IDictionary<Type, Func<IEntity>> TypeInitializers { get; private set; }

        static EntityFactory()
        {
            TypeInitializers = new Dictionary<Type, Func<IEntity>>();
        }

        public IEntity Create(Type entityType)
        {
            return TypeInitializers[entityType].Invoke();
        }
    }
}