using System.Collections;
using Cmt6.Exceptions;

namespace Cmt6.Models.Mock
{
    public class News : INews
    {
        static News()
        {
            EntityFactory.TypeInitializers.Add(typeof(INews), () => new News());
        }

        public News()
        {
            ExtendProperties = new Hashtable();
        }

        public int Id { get; set; }

        public string Title { get; set; }

        public string Detail { get; set; }

        public IDictionary ExtendProperties { get; set; }

        public object this[string property]
        {
            get
            {
                try
                {
                    return this.GetPublicPropertyValue(property);
                }
                catch (PropertyNotFoundException)
                {
                    return ExtendProperties[property];
                }
            }
            set
            {
                try
                {
                    this.SetPublicPropertyValue(property, value);
                }
                catch (PropertyNotFoundException)
                {
                    ExtendProperties[property] = value;
                }
            }
        }
    }
}