﻿using System.Linq;
using System.Web.Mvc;
using Cmt6.Models;
using Cmt6.Repositories;

namespace Cmt6.Presentations.Mvc2.Controllers
{
    public class ContentEntityControllerBase<TEntity> : EntityControllerBase<TEntity>
        where TEntity : IContentEntity
    {
        public IEntityRepository<IListView<TEntity>> EntityListViewRepository { get; set; }
        public IEntityRepository<IProperty<TEntity>> EntityPropertyRepository { get; set; }

        //public ViewResult Properties()
        //{
        //    return View("index", EntityPropertyRepository.FindAll());
        //}

        public override ViewResult Index()
        {
            ViewData.Add("properitesToDisplay", EntityUtil.GetReadablePropertiesName(typeof(TEntity)));
            return base.Index();
        }

        public override ViewResult Create()
        {
            ViewData.Add("properitesToDisplay", EntityUtil.GetReadablePropertiesName(typeof(TEntity)));
            return base.Create();
        }

        public override ViewResult Edit(int id)
        {
            ViewData.Add("properitesToDisplay", EntityUtil.GetReadablePropertiesName(typeof(TEntity)));
            return base.Edit(id);
        }

        public ViewResult Views(int id)
        {
            var view = EntityListViewRepository.FindById(id);
            if (view == null)
            {
                view = EntityFactory.Create(typeof(IListView<TEntity>)) as IListView<TEntity>;
                view.Id = id;
                view.ProperitesToDisplay = EntityPropertyRepository.FindAll().ToList();
                EntityListViewRepository.Add(view);
            }
            ViewData.Add("properitesToDisplay", view.ProperitesToDisplay.Select(p => p.Name));
            return View(IndexViewName, EntityRepository.FindBySpecification(view.Filter));
        }
    }
}
