﻿using System;
using System.Web.Mvc;
using System.Web.Routing;
using Cmt6.Models;
using Cmt6.Presentations.Mvc2.ModelBinders;
using Spring.Context.Support;

namespace Cmt6.Presentations.Mvc2
{
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801

    public class MvcApplication : Spring.Web.Mvc.SpringMvcApplication
    {
        public IEntityBinder EntityBinder
        {
            get { return ContextRegistry.GetContext().GetObject("entityBinder") as IEntityBinder; }
        }

        protected override void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapRoute(
                "Default", // Route name
                "{controller}/{action}/{id}", // URL with parameters
                new { controller = "Home", action = "Index", id = UrlParameter.Optional } // Parameter defaults
            );
            routes.MapRoute(
                "View", // Route name
                "{controller}/{action}/{id}/views/{viewId}", // URL with parameters
                new { controller = "Home", action = "Index", id = UrlParameter.Optional, viewId = UrlParameter.Optional } // Parameter defaults
            );

        }



        protected override void Application_Start(object sender, EventArgs e)
        {
            base.Application_Start(sender, e);
            foreach (var entityType in EntityBinder.TypesHandled)
            {
                System.Web.Mvc.ModelBinders.Binders.Add(entityType, EntityBinder);
            }
            System.Web.Mvc.ModelBinders.Binders.Add(typeof(Type), new TypeBinder());
            System.Web.Mvc.ModelBinders.Binders.Add(typeof (Func<INews, bool>), new LambdaExpressionBinder<INews>());
        }
    }
}