using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;
using Cmt6.Models;

namespace Cmt6.Presentations.Mvc2.ModelBinders
{
    public class EntityBinder : DefaultModelBinder, IEntityBinder
    {
        public IEnumerable<Type> TypesHandled { get; set; }
        public IEntityFactory EntityFactory { get; set; }

        protected override object CreateModel(ControllerContext controllerContext, ModelBindingContext bindingContext, Type modelType)
        {
            return modelType.GetInterfaces().Any(i => i.Equals(typeof(IEntity)))
                       ? EntityFactory.Create(modelType)
                       : base.CreateModel(controllerContext, bindingContext, modelType);
        }
    }
}