using System;
using System.Linq;
using Cmt6.Models;
using Cmt6.Models.LinqToSql;

namespace Cmt6.Repositories.LinqToSql
{
    public class NewsListViewRepository : MockEntityRepositoryBase<IListView<INews>>
    {
        //private readonly IEntityRepository<IProperty<INews>> m_entityPropertyRepository = new NewsPropertyRepository();
        public IEntityRepository<IProperty<INews>> EntityPropertyRepository { get; set; }

        public override System.Collections.Generic.IEnumerable<IListView<INews>> FindAll()
        {
            if (Entities.Count == 0)
            {
                Entities = Entities.Union(new[]
                                          {
                                              new ListView<INews>
                                                  {
                                                      Id = 1,
                                                      Filter = null,
                                                      ProperitesToDisplay =
                                                          EntityPropertyRepository.FindAll().ToList()
                                                  },
                                              new ListView<INews>
                                                  {
                                                      Id = 2,
                                                      Filter = null,
                                                      ProperitesToDisplay =
                                                          EntityPropertyRepository.FindAll()
                                                          .Where(
                                                              p =>
                                                              !p.Name.Equals("Detail",
                                                                             StringComparison.OrdinalIgnoreCase))
                                                          .ToList()
                                                  },
                                              new ListView<INews>
                                                  {
                                                      Id = 3,
                                                      Filter = news => news.Id != 1,
                                                      ProperitesToDisplay =
                                                          EntityPropertyRepository.FindAll().ToList()
                                                  },
                                          }).ToList();
            }
            return base.FindAll();
        }

        public override IListView<INews> FindById(int id)
        {
            return base.FindById(id) ?? new ListView<INews>
                                            {
                                                Id = GenerateNextId(),
                                                Filter = null,
                                                ProperitesToDisplay = EntityPropertyRepository.FindAll().ToList()
                                            };
        }
    }
}