using System;
using System.Linq;
using Cmt6.Models;
using Cmt6.Models.Mock;

namespace Cmt6.Repositories.Mock
{
    public class NewsListViewRepository : MockEntityRepositoryBase<IListView<INews>>
    {
        private readonly IEntityRepository<IProperty<INews>> m_entityPropertyRepository = new NewsPropertyRepository();

        public NewsListViewRepository()
        {
            Entities = Entities.Union(new[]
                                          {
                                              new ListView<INews>
                                                  {
                                                      Id = 1,
                                                      Filter = null,
                                                      ProperitesToDisplay =
                                                          m_entityPropertyRepository.FindAll().ToList()
                                                  },
                                              new ListView<INews>
                                                  {
                                                      Id = 2,
                                                      Filter = null,
                                                      ProperitesToDisplay =
                                                          m_entityPropertyRepository.FindAll()
                                                          .Where(
                                                              p =>
                                                              !p.Name.Equals("Detail",
                                                                             StringComparison.OrdinalIgnoreCase))
                                                          .ToList()
                                                  },
                                              new ListView<INews>
                                                  {
                                                      Id = 3,
                                                      Filter = news => news.Id != 1,
                                                      ProperitesToDisplay =
                                                          m_entityPropertyRepository.FindAll().ToList()
                                                  },
                                          }).ToList();
        }
    }
}