using System;
using System.Collections.Generic;
using System.Linq;
using Cmt6.Models;

namespace Cmt6.Repositories
{
    public abstract class EntityRepositoryBase<TEntity> : IEntityRepository<TEntity>
        where TEntity : IEntity
    {
        public abstract IEnumerable<TEntity> FindAll();
        public virtual IEnumerable<TEntity> FindBySpecification(Func<TEntity, bool> specification)
        {
            var rv = FindAll();
            if (specification != null)
                rv = FindAll().Where(specification);
            return rv;
        }

        public virtual TEntity FindById(int id)
        {
            return FindAll().FirstOrDefault(model => model.Id.Equals(id));
        }

        public abstract void Add(TEntity model);
        public abstract void Delete(TEntity model);
        public abstract void Update(TEntity model);
        public abstract void AddOrUpdate(TEntity model);
    }
}