using System;
using System.Collections.Generic;
using Cmt6.Models;

namespace Cmt6.Repositories
{
    public interface IEntityRepository<TEntity>
        where TEntity : IEntity
    {
        IEnumerable<TEntity> FindAll();
        IEnumerable<TEntity> FindBySpecification(Func<TEntity, bool> specification);
        TEntity FindById(int id);
        void Add(TEntity model);
        void Delete(TEntity model);
        void Update(TEntity model);
        void AddOrUpdate(TEntity model);
    }
}