// Type: LinqToCodedom.Generator.Emit
// Assembly: LinqToCodedom, Version=1.0.0.0, Culture=neutral, PublicKeyToken=8b32a020163181f7
// Assembly location: D:\work\ctx\CMT45\Reshearch\DynamicComponent\lib\LinqToCodedom.dll

using LinqToCodedom;
using LinqToCodedom.CodeDomPatterns;
using System;
using System.CodeDom;
using System.Collections.Generic;
using System.Linq.Expressions;

namespace LinqToCodedom.Generator
{
    public static class Emit
    {
        public static CodeStatement label(string label);
        public static CodeStatement @goto(string label);
        public static CodeVariableDeclarationStatement declare(CodeTypeReference type, string varName);
        public static CodeVariableDeclarationStatement declare(string type, string varName);

        public static CodeVariableDeclarationStatement declare(CodeTypeReference type, string varName,
                                                               Expression<Action> exp);

        public static CodeVariableDeclarationStatement declare(string type, string varName, Expression<Action> exp);
        public static CodeVariableDeclarationStatement declare(Type type, string varName, Expression<Action> exp);
        public static CodeVariableDeclarationStatement declare(Type type, string varName);

        public static CodeVariableDeclarationStatement declare<TResult>(string varName,
                                                                        Expression<Func<TResult>> initExp);

        public static CodeVariableDeclarationStatement declare<T, TResult>(string varName,
                                                                           Expression<Func<T, TResult>> initExp);

        public static CodeVarStatement declareVar<TResult>(string varName, Expression<Func<TResult>> initExp);
        public static CodeVarStatement declareVar<T, TResult>(string varName, Expression<Func<T, TResult>> initExp);
        public static CodeThrowExceptionStatement @throw(Expression<Action> exp);
        public static CodeContinueForStatement continueFor();
        public static CodeContinueDoStatement continueDo();
        public static CodeExitForStatement exitFor();
        public static CodeExitDoStatement exitDo();
        public static CodeExitDoStatement exitWhile();
        public static CodeExitSelectStatement exitSwitch();

        public static CodeConditionStatement @if<T>(Expression<Func<T, bool>> condition,
                                                    params CodeStatement[] trueStatements);

        public static CodeConditionStatement @if(Expression<Func<bool>> condition, params CodeStatement[] trueStatements);

        public static CodeConditionStatement @if<T, T2>(Expression<Func<T, T2, bool>> condition,
                                                        params CodeStatement[] trueStatements);

        public static CodeConditionStatement @if<T, T2, T3>(Expression<Func<T, T2, T3, bool>> condition,
                                                            params CodeStatement[] trueStatements);

        public static CodeConditionStatement ifelse(Expression condition, CodeStatement[] trueStatements,
                                                    params CodeStatement[] falseStatements);

        public static CodeConditionStatement ifelse(Expression<Func<bool>> condition, CodeStatement[] trueStatements,
                                                    params CodeStatement[] falseStatements);

        public static CodeConditionStatement ifelse<T>(Expression<Func<T, bool>> condition,
                                                       CodeStatement[] trueStatements,
                                                       params CodeStatement[] falseStatements);

        public static CodeConditionStatement ifelse<T, T1>(Expression<Func<T, T1, bool>> condition,
                                                           CodeStatement[] trueStatements,
                                                           params CodeStatement[] falseStatements);

        public static CodeTryCatchFinallyStatement trycatch(params CodeStatement[] statements);

        public static CodeUsingStatement @using<TResult, T>(Expression<Func<TResult, T>> exp,
                                                            params CodeStatement[] stmt);

        public static CodeUsingStatement @using<TResult>(Expression<Func<TResult>> exp, params CodeStatement[] stmt);

        public static CodeUsingStatement @using<TResult, T>(string varName, Expression<Func<TResult, T>> exp,
                                                            params CodeStatement[] stmt);

        public static CodeUsingStatement @using<TResult>(string varName, Expression<Func<TResult>> exp,
                                                         params CodeStatement[] stmt);

        public static CodeUsingStatement @using<TResult>(CodeTypeReference varType, string varName,
                                                         Expression<Func<TResult>> exp, params CodeStatement[] stmt);

        public static CodeStatement @return();
        public static CodeStatement @return(CodeExpression exp);
        public static CodeStatement @return<TResult>(Expression<Func<TResult>> exp);
        public static CodeStatement @return<TResult, T>(Expression<Func<TResult, T>> exp);
        public static CodeStatement @return<TResult>(Expression<Action<TResult>> exp);
        public static CodeStatement @return<TResult, T, T2>(Expression<Func<TResult, T, T2>> exp);
        public static CodeDoStatement @do(Expression<Func<bool>> testExp, params CodeStatement[] statements);
        public static CodeDoStatement @do<T>(Expression<Func<bool, T>> testExp, params CodeStatement[] statements);

        public static CodeDoStatement @do<T, T2>(Expression<Func<bool, T, T2>> testExp,
                                                 params CodeStatement[] statements);

        public static CodeDoStatement @do<T, T2, T3>(Expression<Func<bool, T, T2, T3>> testExp,
                                                     params CodeStatement[] statements);

        public static CodeIterationStatement @for<TResult, T, T2, T3>(string varName,
                                                                      Expression<Func<T, TResult>> initStmt,
                                                                      Expression<Func<T2, bool>> testStmt,
                                                                      Expression<Func<T3, TResult>> incStmt,
                                                                      params CodeStatement[] statements);

        public static CodeIterationStatement @for<TResult, T, T2>(string varName, Expression<Func<T, TResult>> initStmt,
                                                                  Expression<Func<T2, bool>> testStmt,
                                                                  Expression<Func<TResult>> incStmt,
                                                                  params CodeStatement[] statements);

        public static CodeIterationStatement @for<TResult, T, T2, T3>(Expression<Func<string>> varName,
                                                                      Expression<Func<T, T3, TResult>> initStmt,
                                                                      Expression<Func<T2, bool>> testStmt,
                                                                      Expression<Func<TResult>> incStmt,
                                                                      params CodeStatement[] statements);

        public static CodeLockStatement @lock<TResult, T>(Expression<Func<TResult, T>> exp, params CodeStatement[] stmt);
        public static CodeLockStatement @lock<TResult>(Expression<Func<TResult>> exp, params CodeStatement[] stmt);

        public static CodeForeachStatement @foreach<TResult>(string varName,
                                                             Expression<Func<IEnumerable<TResult>>> iterStmt,
                                                             params CodeStatement[] statements);

        public static CodeForeachStatement @foreach<TResult, T>(string varName,
                                                                Expression<Func<T, IEnumerable<TResult>>> iterStmt,
                                                                params CodeStatement[] statements);

        public static CodeForeachStatement @foreach<TResult, T, T2>(string varName,
                                                                    Expression<Func<T, T2, IEnumerable<TResult>>>
                                                                        iterStmt, params CodeStatement[] statements);

        public static CodeForeachStatement @foreach<TResult, T, T2, T3>(string varName,
                                                                        Expression
                                                                            <Func<T, T2, T3, IEnumerable<TResult>>>
                                                                            iterStmt, params CodeStatement[] statements);

        public static CodeForeachStatement @foreach<TResult>(CodeTypeReference type, string varName,
                                                             Expression<Func<IEnumerable<TResult>>> iterStmt,
                                                             params CodeStatement[] statements);

        public static CodeForeachStatement @foreach<TResult, T>(CodeTypeReference type, string varName,
                                                                Expression<Func<T, IEnumerable<TResult>>> iterStmt,
                                                                params CodeStatement[] statements);

        public static CodeForeachStatement @foreach<TResult, T, T2>(CodeTypeReference type, string varName,
                                                                    Expression<Func<T, T2, IEnumerable<TResult>>>
                                                                        iterStmt, params CodeStatement[] statements);

        public static CodeForeachStatement @foreach<TResult, T, T2, T3>(CodeTypeReference type, string varName,
                                                                        Expression
                                                                            <Func<T, T2, T3, IEnumerable<TResult>>>
                                                                            iterStmt, params CodeStatement[] statements);

        public static CodeStatement stmt(Expression<Action> exp);
        public static CodeStatement stmt<T>(Expression<Action<T>> exp);
        public static CodeStatement stmt<T, T2>(Expression<Action<T, T2>> exp);
        public static CodeStatement stmt<TResult>(Expression<Func<TResult>> exp);
        public static CodeStatement stmt<TResult, T>(Expression<Func<TResult, T>> exp);
        public static CodeWhileStatement @while(Expression<Func<bool>> testExp, params CodeStatement[] statements);
        public static CodeWhileStatement @while<T>(Expression<Func<bool, T>> testExp, params CodeStatement[] statements);

        public static CodeWhileStatement @while<T, T2>(Expression<Func<bool, T, T2>> testExp,
                                                       params CodeStatement[] statements);

        public static CodeWhileStatement @while<T, T2, T3>(Expression<Func<bool, T, T2, T3>> testExp,
                                                           params CodeStatement[] statements);

        public static CodeSwitchStatement @switch<TResult>(Expression<Func<TResult>> switchExp);
        public static CodeSwitchStatement @switch<TResult, T>(Expression<Func<TResult, T>> switchExp);

        public static CodeAttachEventStatement attachDelegate(Base owner, string eventName, Base target,
                                                              string methodName);

        public static CodeRemoveEventStatement detachDelegate(Base owner, string eventName, Base target,
                                                              string methodName);

        public static CodeAttachEventStatement attachDelegate(Base owner, string eventName, string staticMethodName);
        public static CodeRemoveEventStatement detachDelegate(Base owner, string eventName, string staticMethodName);
        public static CodeAssignStatement assignExp<TResult, T>(Expression<Func<TResult, T>> target, CodeExpression exp);
        public static CodeAssignStatement assignExp<TResult>(Expression<Func<TResult>> target, CodeExpression exp);
        public static CodeAssignStatement assignVar<TResult, T>(string varName, Expression<Func<TResult, T>> exp);
        public static CodeAssignStatement assignVar<TResult>(string varName, Expression<Func<TResult>> exp);
        public static CodeAssignStatement assignVar(string varName, CodeExpression exp);

        public static CodeAssignStatement assignField<TResult, T>(CodeExpression target, string fieldName,
                                                                  Expression<Func<TResult, T>> exp);

        public static CodeAssignStatement assignField<TResult>(CodeExpression target, string fieldName,
                                                               Expression<Func<TResult>> exp);

        public static CodeAssignStatement assignField<TResult>(CodeExpression target, string fieldName,
                                                               CodeExpression exp);

        public static CodeAssignStatement assignField<TResult, T>(string fieldName, Expression<Func<TResult, T>> ex);
        public static CodeAssignStatement assignField<TResult>(string fieldName, Expression<Func<TResult>> exp);
        public static CodeAssignStatement assignField<TResult>(string fieldName, CodeExpression exp);

        public static CodeAssignStatement assignProperty<TResult, T>(CodeExpression target, string propertyName,
                                                                     Expression<Func<TResult, T>> ex);

        public static CodeAssignStatement assignProperty<TResult>(CodeExpression target, string propertyName,
                                                                  Expression<Func<TResult>> exp);

        public static CodeAssignStatement assignProperty(CodeExpression target, string propertyName, CodeExpression exp);

        public static CodeAssignStatement assignProperty<TResult, T>(string propertyName,
                                                                     Expression<Func<TResult, T>> exp);

        public static CodeAssignStatement assignProperty<TResult>(string propertyName, Expression<Func<TResult>> exp);
        public static CodeAssignStatement assignDelegate(string varName, Base target, string methodName);
        public static CodeAssignStatement assignDelegate(string varName, string methodName);
    }
}
